local RQ = select(2,...)
RQ = LibStub("AceAddon-3.0"):NewAddon(RQ, "RandomQuoter", "AceConsole-3.0", "AceEvent-3.0")
local AceGUI = LibStub("AceGUI-3.0")
RQ.version = GetAddOnMetadata("RandomQuoter", "Version")

local PREVIOUS_TIME = 0;
local CURRENT_TIME;
local EPOCH_MINUTE = 60;
local TIME_DROPDOWN = {[1] = 1, [5] = 5, [10] = 10, [20] = 20, [30] = 30, [40] = 40, [50] = 50, [60] = 60}

local ModulesDropDown = {} -- module list for the dropdown menu

--- slash commands
RQ:RegisterChatCommand("rqmodules", "rqmodules")
RQ:RegisterChatCommand("rq", "Options")
RQ:RegisterChatCommand("rqrand", "Randomizer")

function RQ:rqmodules()
	for i,v in pairs(ModulesDropDown) do
		print(i,v)
	end
end

local savedDBDefaults = { --- Default the saved variables
	global = {
		QuoteModule = "Default",
		AddonEnabled = true,
		AddonTime = 5, -- in epoch -- default 5
	},
}

function RQ:OnEnable()
	RQ:RegisterEvent("CHAT_MSG_GUILD")
	RQ:RegisterEvent("CHAT_MSG_SAY")
	RQ:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	RQ.db = LibStub:GetLibrary("AceDB-3.0"):New("RandomQuoterDB", savedDBDefaults, true)
	RQ.CurrentModule = RQ.db.global.QuoteModule ------------ current module here for loading pleasure
	RQ:Randomizer() -- shits and giggles login

end

function RQ:COMBAT_LOG_EVENT_UNFILTERED()
	RQ:Randomizer()
end

function RQ:CHAT_MSG_GUILD()
	RQ:Randomizer()
end

function RQ:CHAT_MSG_SAY()	
	RQ:Randomizer()
end


function RQ:Randomizer() -- Main Quote Randomizer
	RQ:GetModuleName(RQ.Modules) -- load module names
	RQ.CurrentModule = RQ.db.global.QuoteModule --- loads DB value into current module
	if RQ.Modules[RQ.CurrentModule] == nil then -- Default the module if the current one isnt found
		RQ.db.global.QuoteModule = "Default"
		RQ.CurrentModule = RQ.db.global.QuoteModule
	end
	--print(RQ.Modules[RQ.CurrentModule])
	if RQ.db.global.AddonEnabled == true then
		CURRENT_TIME = time()
		if CURRENT_TIME >= (PREVIOUS_TIME + (EPOCH_MINUTE * RQ.db.global.AddonTime)) then
			PREVIOUS_TIME = time()
			local MaxRand = getn(RQ.Modules[RQ.CurrentModule])  -- gets the max number of rand from the length of current module
			local Random = random(1,MaxRand) -- random the number
			local QuoteModule = RQ.Modules[RQ.CurrentModule] -- load the module into the wanted module
			local Quote = QuoteModule[Random] -- get the quote
			--print(Quote)
			SendChatMessage(Quote,"SAY") -- print the quote to say
		end
	end
end

function RQ:GetModuleName(Modules) -- Load modules into modules dropdown for dropdown menu selection
	for i,v in pairs(Modules) do
		ModulesDropDown[i] = i
	end
end

function RQ:Options() --- the GUI
	local Frame = AceGUI:Create("Frame")
	Frame:SetTitle("Random Quoter")
	Frame:SetStatusText("Random Quoter: V"..RQ.version)
	Frame:EnableResize(false)
	Frame:SetWidth(440)
	Frame:SetHeight(150)
	Frame:SetCallback("OnClose", function(widget) AceGUI:Release(widget); end)
	Frame:SetLayout("Flow")
	
	local ModuleDropDown = AceGUI:Create("Dropdown")
	ModuleDropDown:SetValue(RQ.db.global.QuoteModule)
	ModuleDropDown:SetList(ModulesDropDown)
	ModuleDropDown:SetText("Select the Module:")
	ModuleDropDown:SetCallback("OnValueChanged", function(key1,key2,key3,key4)
		RQ.db.global.QuoteModule = key3
	end)
	Frame:AddChild(ModuleDropDown)
	
	local AddonEnabledCheckbox = AceGUI:Create("CheckBox")
	AddonEnabledCheckbox:SetValue(RQ.db.global.AddonEnabled)
	AddonEnabledCheckbox:SetLabel("Enable/Disable")
	AddonEnabledCheckbox:SetDisabled(false)
	AddonEnabledCheckbox:SetCallback("OnValueChanged", function(a,b,c) --[[print(a,b,c)]] RQ.db.global.AddonEnabled = c end)
	Frame:AddChild(AddonEnabledCheckbox)
	
	local TimeDropDown = AceGUI:Create("Dropdown")
	TimeDropDown:SetValue(RQ.db.global.AddonTime)
	TimeDropDown:SetList(TIME_DROPDOWN)
	TimeDropDown:SetText("Select the Time")
	TimeDropDown:SetCallback("OnValueChanged", function(key1,key2,key3,key4)
		RQ.db.global.AddonTime = key3
	end)
	Frame:AddChild(TimeDropDown)
	
	local TestButton = AceGUI:Create("Button")
	TestButton:SetText("Test")
	TestButton:SetWidth(75)
	TestButton:SetHeight(30)
	TestButton:SetCallback("OnClick", function() RQ:Randomizer() end)
	Frame:AddChild(TestButton)
end